package PC20050922;

import java.util.*;
import ProSW.*;

public class Indirizzo implements Cloneable {
	private String via;
	private String civico;
	
	// Coordinate dell'indirizzo rispetto ad un piano cartesiano di riferimento: 
	// consentono una semplice implementazione per il calcolo della distanza (non richiesto)
	private int x, y; 

	public Indirizzo(String via, String civico, int xx, int yy ) throws EccezionePrecondizioni {
		setVia(via);
		setCivico(civico);
		x = xx; y = yy;
	}
	public String getVia() { return via; }
	public void setVia(String v) throws EccezionePrecondizioni { 
		if (v != null) via = v; // schema CON condiv!!
		else throw new EccezionePrecondizioni("La via non pu essere null");
	}
	public String getCivico() { return civico; }
	public void setCivico(String c) throws EccezionePrecondizioni { 
		if (c != null) civico = c; 
		else throw new EccezionePrecondizioni("Il civico non pu essere null");
	}

	public int getX() { return x; }
	public int getY() { return y; }
	private void setCoordinate(int xx, int yy) {
		x = xx; y = yy;
	}

	public boolean equals(Object o) {
		if (o != null && getClass().equals(o.getClass())) {
			Indirizzo i = (Indirizzo)o;
			return i.via.equals(via) &&
				   i.civico.equals(civico);
		}
		return false;
	}
	public int hashCode() { return via.hashCode()+civico.hashCode(); }

	public Object clone() {
		try {
			Indirizzo i = (Indirizzo)super.clone(); 
			return i;
		} catch (CloneNotSupportedException e) {
			// non puo' accadere, ma va comunque gestito
			throw new InternalError(e.toString());
		}
	}
	
	public double distanzaDa(Indirizzo altro) {
		return Math.sqrt(
			Math.pow(x - altro.x, 2) + Math.pow(y - altro.y, 2)
		);
	}
	
} //:~
